/*******************************************************************************
 * Copyright (c) 2011 INRIA. 
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Original Contributors: 
 *     Frederic Jouault (INRIA) - initial API and implementation
 * Adaptation to MoScript:
 *     Wolfgang Kling - AtlanMod (EMN, INRIA, LINA)
 *  
 ******************************************************************************/
package org.eclipse.am3.moscript.dsls;

import java.net.URL;

import org.eclipse.am3.moscript.dsls.textsource.TextSource;
import org.eclipse.emf.common.util.URI;

/**
 * The Resource interface.
 * 
 * @author <a href="mailto:frederic.jouault@univ-nantes.fr">Frederic Jouault</a>  
 * @author <a href="mailto:wolfgang.kling@inria.fr">Wolfgang Kling</a>
*/
public interface Resource {

	/**
	 * Returns a text source based on the current resource.
	 * 
	 * @return a text source based on the current resource
	 */
	TextSource asTextSource();

	/**
	 * Returns the URL of the resource.
	 * 
	 * @return the URL of the resource
	 */
	URL asURL();

	/**
	 * Returns the EMF URI of the resource.
	 * 
	 * @return the EMF URI of the resource
	 */
	URI asEMFURI();
}
