/*******************************************************************************
 * Copyright (c) 2011 INRIA. 
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Original Contributors: 
 *     Frederic Jouault - INRIA - initial API and implementation
 * Adaptation to MoScript:
 *     Wolfgang Kling - AtlanMod (EMN, INRIA, LINA)
 *  
 ******************************************************************************/
package org.eclipse.am3.moscript.dsls.tcs.extractor;

/**
 * 
 * @author <a href="mailto:frederic.jouault@univ-nantes.fr">Frederic Jouault</a>
 * @author <a href="mailto:wolfgang.kling@inria.fr">Wolfgang Kling</a>
 */
public interface TCSExtractorStream {

	void close();

	void debug(String string);

	void printWhiteSpace(String ws);

	void printKeyword(String keyword);

	void printSymbol(String symbol);

	void printIdentifier(String ident);

	void printEscapedIdentifier(String identEscStart, String ident, String identEscEnd);

	void printBoolean(boolean v);

	void printInteger(int v);

	void printReal(String string);

	void printString(String stringDelim, String v);

	void printComment(String c);

}
