lexer grammar MoScript_ANTLR3;
@members {

	private void newline() {}

	public org.eclipse.gmt.tcs.injector.TCSRuntime ei = null;

	public void displayRecognitionError(String[] tokenNames, RecognitionException e) {
		ei.reportError((Exception)e);
	}

	public Token emit() {
		org.eclipse.m2m.atl.dsls.tcs.injector.wrappers.antlr3.ANTLR3LocationToken ret = null;

		ret = new org.eclipse.m2m.atl.dsls.tcs.injector.wrappers.antlr3.ANTLR3LocationToken(input, type, channel, tokenStartCharIndex, getCharIndex()-1);
		ret.setLine(tokenStartLine);
		ret.setText(text);
	  	ret.setCharPositionInLine(tokenStartCharPositionInLine);
		ret.setEndLine(getLine());
		ret.setEndColumn(getCharPositionInLine());
		emit(ret);

		return ret;
	}

}
@header {package org.eclipse.m2m.atl.dsls.tcs.injector;}

T42 : 'library' ;
T43 : 'query' ;
T44 : 'program' ;
T45 : 'using' ;
T46 : 'do' ;
T47 : '<:=' ;
T48 : 'if' ;
T49 : 'else' ;
T50 : 'for' ;
T51 : 'in' ;
T52 : 'save' ;
T53 : 'to' ;
T54 : 'as' ;
T55 : 'into' ;
T56 : 'remove' ;
T57 : 'from' ;
T58 : 'iterate' ;
T59 : 'OclUndefined' ;
T60 : 'true' ;
T61 : 'false' ;
T62 : 'then' ;
T63 : 'endif' ;
T64 : 'super' ;
T65 : 'let' ;
T66 : 'Bag' ;
T67 : 'Set' ;
T68 : 'OrderedSet' ;
T69 : 'Sequence' ;
T70 : 'Map' ;
T71 : 'Tuple' ;
T72 : 'OclType' ;
T73 : 'OclAny' ;
T74 : 'TupleType' ;
T75 : 'Integer' ;
T76 : 'Real' ;
T77 : 'Boolean' ;
T78 : 'String' ;
T79 : 'Collection' ;
T80 : 'uses' ;
T81 : 'helper' ;
T82 : 'def' ;
T83 : 'context' ;
T84 : 'not' ;
T85 : 'div' ;
T86 : 'mod' ;
T87 : 'and' ;
T88 : 'or' ;
T89 : 'xor' ;
T90 : 'implies' ;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 946
NL
	:	(	'\r' '\n'
		|	'\n' '\r'	//Improbable
		|	'\r'
		|	'\n'
		)
	{newline();}
	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 955
WS
	:	(	' '
		|	'\t'
		)
	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 961
fragment
DIGIT
	:	'0'..'9'
	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 966
fragment
ALPHA
	:	'a'..'z'
	|	'A'..'Z'
	|	'_'
	//For Unicode compatibility (from 0000 to 00ff)
	|	'\u00C0' .. '\u00D6'
	|	'\u00D8' .. '\u00F6'
	|	'\u00F8' .. '\u00FF'
	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 977
fragment
SNAME
//	options {
//		testLiterals = true;
//	}
	:	(ALPHA) (ALPHA | DIGIT)*
;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 985
NAME
	:	(
			SNAME
//			s:SNAME {if(s.getType() != SNAME) $setType(s.getType());}
		|	'"'!
			(	ESC
			|	'\n' {newline();}
			|	~('\\'|'\"'|'\n')
			)*
			'"'!
			{setText(ei.unescapeString(getText(), 1));}
		)
	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 999
INT
	:	(DIGIT)+
//		(('.' DIGIT)=> '.' (DIGIT)+ {$setType(FLOAT);})?
	;

	// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1004
FLOAT	:	DIGIT+ '.' DIGIT*	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1006
fragment
ESC
	:	'\\'!
		(	'n' //{setText("\n");}
		|	'r' //{setText("\r");}
		|	't' //{setText("\t");}
		|	'b' //{setText("\b");}
		|	'f' //{setText("\f");}
		|	'"' //{setText("\"");}
		|	'\'' //{setText("\'");}
		|	'\\' //{setText("\\");}
		|	(
				('0'..'3')
				(
//					options {
//						warnWhenFollowAmbig = false;
//					}
				:	('0'..'7')
					(
//						options {
//							warnWhenFollowAmbig = false;
//						}
					:	'0'..'7'
					)?
				)?
			|	('4'..'7')
				(
//					options {
//						warnWhenFollowAmbig = false;
//					}
				:	('0'..'7')
				)?
			)
				{
//					String s = getText();
//					int i;
//					int ret = 0;
//					String ans;
//					for (i=0; i<s.length(); ++i)
//						ret = ret*8 + s.charAt(i) - '0';
//					ans = String.valueOf((char) ret);
//					setText(ans);
				}
		)
	;
	

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1053
LSQUARE @init {}
	:	'['
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1061
RSQUARE @init {}
	:	']'
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1069
EXCL @init {}
	:	'!'
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1077
COMA @init {}
	:	','
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1085
LPAREN @init {}
	:	'('
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1093
RPAREN @init {}
	:	')'
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1101
LCURLY @init {}
	:	'{'
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1109
RCURLY @init {}
	:	'}'
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1117
SEMI @init {}
	:	';'
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1125
COLON @init {}
	:	':'
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1133
PIPE @init {}
	:	'|'
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1141
SHARP @init {}
	:	'#'
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1149
QMARK @init {}
	:	'?'
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1157
COLONCOLON @init {}
	:	'::'
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1165
POINT @init {}
	:	'.'
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1173
RARROW @init {}
	:	'->'
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1181
MINUS @init {}
	:	'-'
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1189
STAR @init {}
	:	'*'
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1197
SLASH @init {}
	:	'/'
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1205
PLUS @init {}
	:	'+'
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1213
EQ @init {}
	:	'='
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1221
GT @init {}
	:	'>'
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1229
LT @init {}
	:	'<'
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1237
GE @init {}
	:	'>='
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1245
LE @init {}
	:	'<='
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1253
NE @init {}
	:	'<>'
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1261
LARROW @init {}
	:	'<-'
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1269
COMMENT @init {}
	:	(('--' (~('\r'| '\n'))*))
        {
            
        }

	;

// $ANTLR src "/Users/wkling09/EclipseWorkspaces/GanymedeOthers/workspace-variousATL2/MoScript/Syntax/MoScript_ANTLR3.g" 1277
STRING @init {}
	:	(('\'' (options {greedy = false;} : (('\\'! ~ '\n')| '\n'| ~('\\'| '\n')))* '\''))
        {
            
        }

	;
