/*******************************************************************************
 * Copyright (c) 2011 INRIA. 
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Original Contributors: 
 *     Frederic Jouault - INRIA - initial API and implementation
 * Adaptation to MoScript:
 *     Wolfgang Kling - AtlanMod (EMN, INRIA, LINA)
 *  
 ******************************************************************************/
package org.eclipse.am3.moscript.dsls.tcs.injector;

import java.util.Set;

/**
 * @author <a href="mailto:frederic.jouault@univ-nantes.fr">Frederic Jouault</a>
 * @author <a href="mailto:wolfgang.kling@inria.fr">Wolfgang Kling</a>
 */
public interface ModelAdapter {
	
	public Object get(Object ame_, String propertyName);

	public Object createElement(String typeName);

	public Set getElementsByType(String typeName);
	
	public Object getType(Object me_);

	public boolean isCandidate(Object ame, String typeName);
	
	public void set(Object ame, String prop, Object value);

	public String getString(Object ame, String propName);
	
	public boolean isAModelElement(Object me);
	
	public Object createEnumLiteral(String name);
	
	public Object getModel();
}